/*
 * ElimClses.hpp
 *
 *  Created on: May 21, 2010
 *      Author: kottlers
 */

#ifndef ELIMCLSES_HPP_
#define ELIMCLSES_HPP_

class ElimCls{
	const ElimCls*	prev;
public:
	const Literal 	ukwn;
	const uint32_t	size;
	Literal			knwn[0];

	ElimCls* 		getPrev()const{return (ElimCls*)prev;}
	ElimCls(const Literal elim, const uint32_t sz,const ElimCls* p)
		:prev(p),ukwn(elim),size(sz){}
};

class ElimClses{
	ElimCls* 		last;

	inline ElimCls* allocate(const Literal elim,const uint32_t size);
public:
	ElimClses():last(NULL){}
	inline ~ElimClses();
	/*only invoked from writing thread*/
	inline void push_back(const Literal elim, SharedClause* cls,const uint32_t& sz);
	inline void push_back(const Literal  elim, Literal kwn);
	inline void push_back(const Variable elim);

	/*can be invoked from any*/
	ElimCls* getLast() const{return last;}
};


void ElimClses::push_back(const Literal elim, SharedClause* cls,const uint32_t& sz){ asrt(sz>2);
	ElimCls* c 	= allocate(elim,sz-1);
	uint32_t e	= 0;
	FOR_LITS_STRT(cls,lit);
		if(lit != elim){c->knwn[e++] = lit;}
	FOR_LITS_END;

	//LOG_BASIC(" ukwn: " << c->ukwn.toDIMACS());
	last		= c;
}


void ElimClses::push_back(const Literal  elim, Literal kwn){
	ElimCls* cls 	= allocate(elim,1);
	//LOG_BASIC("push back elim stack: ");
	cls->knwn[0] 	= kwn; //LOG_BASIC(" ukwn: " << cls->ukwn.toDIMACS() << " kwn: "<< cls->knwn[0].toDIMACS());
	last			= cls;
}

void ElimClses::push_back(const Variable elim){
	ElimCls* cls 	= allocate(elim.toPosLit(),0);
	last			= cls;
}

ElimCls* 	ElimClses::allocate(const Literal elim,const uint32_t size){
	void* mem				= malloc(sizeof(ElimCls) + sizeof(Literal)*size);
	LOG3("Construct elim clause at " << (uint64_t)mem );

	if(mem == NULL){
		fprintf(stderr,"\nc !!!OUT OF MEMORY!!!\n");
		exit(EXIT_FAILURE);}

	ElimCls* cls 	= new (mem) ElimCls(elim,size,last);
 	return cls;
}

ElimClses::~ElimClses(){
	while(last != NULL){
		ElimCls* des 	= last;
		last			= des->getPrev();
		free(des);
	}
}


#endif /* ELIMCLSES_HPP_ */
