#ifndef ASSERTION_HPP_
#define ASSERTION_HPP_
#define assertion_hpp_version	  "$Revision: 1.1 $"

#include <execinfo.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <cassert>
#include <iostream>
#include <sys/resource.h>
#include <omp.h>

/*inline void printStackTrac(std::ofstream& out){

	void *buffer[100];
	int nptrs 		= backtrace(buffer, 100);
   	out << "Call stack depth is " << nptrs << std::endl;

	char **strings 	= backtrace_symbols(buffer, nptrs);

	if (strings == NULL) {
    	out << "Call stack could not be printed" << std::endl;
        return;}

   for(int32_t j = 0; j < nptrs; ++j){
	   out << strings[j] << std::endl;}

   free(strings);
}*/


inline void printStackTrace(){

	struct rusage ru;
	getrusage(RUSAGE_SELF, &ru);
	double sec = (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000.0;

	void *buffer[100];
	int nptrs 		= backtrace(buffer, 100);
	std::cerr << "Stack Trace in thread "<< omp_get_thread_num() <<" after " << sec << " seconds. Stack depth is " << nptrs << std::endl;

    backtrace_symbols_fd(buffer+1, nptrs, STDERR_FILENO);
}




#ifdef NDEBUG
#define aux_var(x)
#define asrt(x) assert(x)
#define sanity(expr)	assert(x)

#else
#define aux_var(x)  x
#define asrt(x)					\
  ((x) ? __ASSERT_VOID_CAST (0)		\
   : (printStackTrace(), __assert_fail (__STRING(x), __FILE__, __LINE__, __ASSERT_FUNCTION), __ASSERT_VOID_CAST (0)))

#ifdef  SANITY_CHECKS
#define sanity(expr)	(asrt(expr))
#else
#define sanity(expr)	(__ASSERT_VOID_CAST (0))
#endif

#endif




#endif
